/**
 *
 * @author Sebastian Widelak (c) 2013
 */
(function (window, undefined) {
    /**
     *
     * @type {function}
     */
    window.ContentsView = View.extend(function ContentsView(opts) {
        View.prototype.constructor.call(this, opts);
        this.set('contentsElements', []);
    });

    ContentsView.prototype.show = function () {
        var me = this,
            contents = me.get('el'),
            $contents = jQuery(contents),
            height = $contents.find('.contents').get(0).offsetHeight;
        $contents.animate({
            top: height
        }, function () {
            me.set('visible', true);
        });
    };

    ContentsView.prototype.hide = function () {
        var me = this,
            contents = me.get('el'),
            $contents = jQuery(contents);
        $contents.animate({
            top: 0
        }, function () {
            me.set('visible', false);
        });
    };


    ContentsView.prototype.adjustTopPosition = function () {
        var me = this,
            contents,
            $contents,
            height;
        if (!this.get('visible')) {
            return;
        }
        contents = me.get('el');
        $contents = jQuery(contents);
        height = $contents.find('.contents').get(0).offsetHeight;
        $contents.stop();
        $contents.css({
            top: height
        });
    };

    ContentsView.prototype.addElement = function (name) {
        var contentsEls = this.get('contentsElements'),
            element;
        if (!name) {
            element = new ContentsElementView({
                config: {
                    tpl: 'content-element',
                    renderTo: 'div.contents-inner',
                    parent: this.get('el'),
                    models: {
                        title : contentsEls.length,
                        i: contentsEls.length,
                        name: contentsEls.length
                    }
                }
            });
        } else {
            element = new ContentsElementView({
                config: {
                    tpl: 'content-element-2',
                    renderTo: 'div.contents-inner',
                    parent: this.get('el'),
                    models: {
                        title : name,
                        i: contentsEls.length,
                        name: name
                    }
                }
            });
        }
        element.render();
        contentsEls.push(element);
    };
}(window));