/**
 *
 * @author Sebastian Widelak (c) 2013
 */
(function (window, undefined) {
    /**
     *
     * @type {function}
     */
    window.SlideView = View.extend(function SlideView(opts) {
        View.prototype.constructor.call(this, opts);
    });

    /**
     *
     * @param item
     * @returns {*}
     */
    SlideView.prototype.generateElement = function (item) {
        var element;
        switch (item.type) {
            case 'title' :
            {
                element = new TitleView({
                    config: {
                        tpl: 'slide-title',
                        renderTo: '.slide-cell',
                        models: item
                    }
                });
                break;
            }
            case 'image' :
            {
                element = new ImageView({
                    config: {
                        tpl: 'slide-image',
                        renderTo: '.slide-cell',
                        models: item
                    }
                });
                break;
            }
            case 'content' :
            {
                element = new ContentView({
                    config: {
                        tpl: 'slide-content',
                        renderTo: '.slide-cell',
                        models: item
                    }
                });
                break;
            }
        }
        element.render();
        return element;
    };

    SlideView.prototype.generateContent = function () {
        var models = this.get('config').models.items || {},
            parent = this.get('el').querySelector('.slide-cell'),
            element;
        for (var i = 0, len = models.length; i < len; i++) {
            element = this.generateElement(models[i]);
            parent.appendChild(element.get('el'));
            this.get('config').views.push(element);
        }
    };
}(window));